/* $Id: net_addr.h,v 1.1 2021/04/24 05:04:50 rlr Exp $ */

/*
 * Copyright (c) 2021 Ross Richardson <rueda@rlr.id.au>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef _NET_ADDR_H_
#define _NET_ADDR_H_

#include <stdbool.h>

/*
 * bool
 * net_addr_match(const char *a, const char *b);
 *
 * Returns true iff a and b, which must be non-NULL and represent valid IP
 * addresses, are either equal, or represent IPv6 addresses which:
 *    - are not scoped (x:x:x:x:x:x:x:x%if)
 *    - are not in mixed notation (x:x:x:x:x:x:d.d.d.d)
 *    - are from a common /64
 */
bool	 net_addr_match(const char *, const char *);

#endif /* !_NET_ADDR_H_ */
